using System;

namespace _3_zad_18_12
{
    class Program
    {
        static void Main(string[] args)
        {
            string originalistring = Console.ReadLine();

            char pomocna;  
            int l = 0, d = 1, e = originalistring.Length - 1;
            char[] noviporedak = originalistring.ToCharArray();
            while (l < d && d < e)
            {
                
                if (noviporedak[l] == noviporedak[e])
                {
                    l++;
                    d++;  
                    e--;
                }
                else if (noviporedak[l] == noviporedak[d])
                {
                    pomocna = noviporedak[d];
                    noviporedak[d] = noviporedak[e];
                    noviporedak[e] = pomocna;

                }
                else if (noviporedak[d] == noviporedak[e])
                {
                    pomocna = noviporedak[l];
                    noviporedak[l] = noviporedak[d];
                    noviporedak[d] = pomocna;
                    d = l + 1;  
                }
                else d++;
            }
        
            int prvapromena=0;
               for(int i = 0; i < originalistring.Length; i++)
            {
                if (noviporedak[i] != originalistring[i])
                {
                    prvapromena = i;
                    break;
                }
            }
            int poslednjapromena=0;
            
            for (int i = originalistring.Length-1; i >=0; i--)
            {
                if (noviporedak[i] != originalistring[i])
                {
                    poslednjapromena = i;
                    break;
                }
            }
            Console.WriteLine(poslednjapromena-prvapromena+1) ;
              
            
        }
    }
}